/***************************************************************************
 *             __________               __   ___.
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 *
 * Copyright (C) 2006 Katie Stafford
 *
 * All files in this archive are subject to the GNU General Public License.
 * See the file COPYING in the source tree root for full license agreement.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/

#ifndef __BOARD_H_
#define __BOARD_H_

#include "common.h"
#include "datafile.h"

#define BNX(x,y) (board[0<<12 |(x)<<6 | (y)])
#define BNY(x,y) (board[1<<12 |(x)<<6 | (y)])
#define BPX(x,y) (board[2<<12 |(x)<<6 | (y)])
#define BPY(x,y) (board[3<<12 |(x)<<6 | (y)])

#define BX(d,x,y) (board[((d)+1)<<12 |(x)<<6 | (y)])
#define BY(d,x,y) (board[((d)+2)<<12 |(x)<<6 | (y)])

#define BCELL(x,y) (board[4<<12 |(x)<<6 | (y)])

#define BSEEN(x,y) (boardseen[(x)<<6 | (y)])
#define FINDBUF(x,y) (findgoalbuf[(x)<<6 | (y)])
#define BOBJ(x,y) (boardactor[(x)<<6 | (y)])

extern uint16 *board;


extern uint8 boardseen[] IBSS_ATTR;
extern uint8 findgoalbuf[] IBSS_ATTR;
extern sint16 boardactor[] IBSS_ATTR;

void findgoal(int x, int y);
int trace(int sx, int sy, int dx, int dy, int *hx, int *hy) ICODE_ATTR;
void board_changed(void);
int loadboard(char*);
void save_board_to(buffer* buf);
void load_board_from(buffer* buf);

#endif
