/***************************************************************************
 *             __________               __   ___.
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 *
 * Copyright (C) 2006 Katie Stafford
 *
 * All files in this archive are subject to the GNU General Public License.
 * See the file COPYING in the source tree root for full license agreement.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/

#include "class.h"

int _default_method() {
    return 0;
}

void object_ref(void* o) {
    if (o)
        ++((object*)o)->refcnt;
}

void object_deref(void* o) {
    if (o && !--((object*)o)->refcnt) {
        CALLMETH((object*)o, fini);
        free(o);
    }
}

void* _object_new(void* class) {
    object *o;

    o = malloc(((baseclass*)class)->size);
    if (!o)
	return NULL;

    o->class = (baseclass*)class;
    o->refcnt = 1;
    CALLMETH(o, init);
    return o;
}
